<?php

namespace App\Controller;

use App\GreetingGenerator;
use Sensio\Bundle\FrameworkExtraBundle\Configuration\Route;
use Symfony\Bundle\FrameworkBundle\Controller\AbstractController;
use Symfony\Component\HttpFoundation\Response;

class DefaultController extends AbstractController {

  /**
   * @return \Symfony\Component\HttpFoundation\Response
   *
   * @Route("/",
   *   name="front"
   * )
   * @Route("/hello",
   *   name="front-hello"
   * )
   */
  public function index() {
    return new Response("Hello");
  }

  /**
   * @param $name
   * @param \App\GreetingGenerator $generator
   *
   * @return \Symfony\Component\HttpFoundation\Response
   *
   * @Route(
   *  name="hello-html",
   *  path="/hello/{name}"
   * )
   */
  public function hello($name, GreetingGenerator $generator) {
    $greeting = $generator->getRandomGreeting();
    return new Response("$greeting $name");
  }

  /**
   * @param $name
   *
   * @return \Symfony\Component\HttpFoundation\JsonResponse
   *
   * @Route("/json/{name}",
   *   name="hello-json",
   * )
   */
  public function helloJson($name) {
    return $this->json([
      'name' => $name,
    ]);
  }
}

